import { world } from '@minecraft/server';
import { ActionFormData, ActionFormResponse, ModalFormResponse, ModalFormData } from '@minecraft/server-ui';


const entityNames = {
    "minecraft:axolotl": "Axolotl",
    "minecraft:bat": "Bat",
    "minecraft:bee": "Bee",
    "minecraft:blaze": "Blaze",
    "minecraft:cat": "Cat",
    "minecraft:cave_spider": "Cave Spider",
    "minecraft:chicken": "Chicken",
    "minecraft:cod": "Cod",
    "minecraft:cow": "Cow",
    "minecraft:creeper": "Creeper",
    "minecraft:dolphin": "Dolphin",
    "minecraft:donkey": "Donkey",
    "minecraft:drowned": "Drowned",
    "minecraft:elder_guardian": "Elder Guardian",
    "minecraft:enderman": "Enderman",
    "minecraft:endermite": "Endermite",
    "minecraft:evoker": "Evoker",
    "minecraft:fox": "Fox",
    "minecraft:frog": "Frog",
    "minecraft:ghast": "Ghast",
    "minecraft:glow_squid": "Glow Squid",
    "minecraft:goat": "Goat",
    "minecraft:guardian": "Guardian",
    "minecraft:hoglin": "Hoglin",
    "minecraft:horse": "Horse",
    "minecraft:husk": "Husk",
    "minecraft:iron_golem": "Iron Golem",
    "minecraft:llama": "Llama",
    "minecraft:magma_cube": "Magma Cube",
    "minecraft:mooshroom": "Mooshroom",
    "minecraft:mule": "Mule",
    "minecraft:ocelot": "Ocelot",
    "minecraft:panda": "Panda",
    "minecraft:parrot": "Parrot",
    "minecraft:phantom": "Phantom",
    "minecraft:pig": "Pig",
    "minecraft:piglin": "Piglin",
    "minecraft:piglin_brute": "Piglin Brute",
    "minecraft:pillager": "Pillager",
    "minecraft:polar_bear": "Polar Bear",
    "minecraft:pufferfish": "Pufferfish",
    "minecraft:rabbit": "Rabbit",
    "minecraft:ravager": "Ravager",
    "minecraft:salmon": "Salmon",
    "minecraft:sheep": "Sheep",
    "minecraft:shulker": "Shulker",
    "minecraft:silverfish": "Silverfish",
    "minecraft:skeleton": "Skeleton",
    "minecraft:skeleton_horse": "Skeleton Horse",
    "minecraft:slime": "Slime",
    "minecraft:snow_golem": "Snow Golem",
    "minecraft:spider": "Spider",
    "minecraft:squid": "Squid",
    "minecraft:stray": "Stray",
    "minecraft:strider": "Strider",
    "minecraft:tadpole": "Tadpole",
    "minecraft:trader_llama": "Trader Llama",
    "minecraft:tropical_fish": "Tropical Fish",
    "minecraft:turtle": "Turtle",
    "minecraft:vex": "Vex",
    "minecraft:villager": "Villager",
    "minecraft:vindicator": "Vindicator",
    "minecraft:wandering_trader": "Wandering Trader",
    "minecraft:warden": "Warden",
    "minecraft:witch": "Witch",
    "minecraft:wither": "Wither",
    "minecraft:wither_skeleton": "Wither Skeleton",
    "minecraft:wolf": "Wolf",
    "minecraft:zoglin": "Zoglin",
    "minecraft:zombie": "Zombie",
    "minecraft:zombie_horse": "Zombie Horse",
    "minecraft:zombie_villager": "Zombie Villager",
    "minecraft:zombified_piglin": "Zombified Piglin",
    "minecraft:tnt": "tnt",
    "minecraft:boat": "boat",
};

world.afterEvents.entitySpawn.subscribe((data) => {
    const entity = data.entity;
    const type = entity.typeId;
    const displayName = entityNames[type] || type;

    entity.runCommandAsync(`scoreboard players random @s level 1 2`)
    entity.runCommandAsync(`scoreboard players random @s effect 1 26`)
    entity.runCommandAsync(`execute if score @s level matches 2 run tag @s add level2`)
    entity.nameTag = `§a${displayName} Normal Race`
    if (entity.hasTag("level2")) { entity.nameTag = `${displayName} High race` }
    entity.nameTag = `${displayName} Normal race`
    if (entity.typeId === "minecraft:tnt") { entity.nameTag = `§c${displayName}` }
    if (entity.typeId === "minecraft:boat") { entity.nameTag = `§n${displayName}` }

});

world.afterEvents.playerSpawn.subscribe((data) => {
    const player = data.player
    player.runCommandAsync("function setup")
    if (!player.hasTag("Joined")) {
        player.runCommandAsync(`tag @s[tag=!Joined] remove skillread`)
        player.runCommandAsync(`tag @s[tag=!Joined] remove ultraunlock`)
        player.runCommandAsync(`tag @s[tag=!Joined] remove blooddemon`)
        player.runCommandAsync(`tag @s[tag=!Joined] remove growth`)
        player.runCommandAsync(`scoreboard players random @s effect 1 26`)
        player.runCommandAsync(`scoreboard players random @s effecta 1 25`)
        player.runCommandAsync(`scoreboard players random @s effectb 1 35`)
        player.runCommandAsync(`effect @s clear`)
        player.runCommandAsync(`tag @s add Joined`)

    }
})


world.afterEvents.entityHitEntity.subscribe((data) => {
    const attacker = data.damagingEntity
    const target = data.hitEntity
    attacker.runCommandAsync(`function blooddemon`)
    target.runCommandAsync(`function growth`)

})

world.afterEvents.itemUse.subscribe((data) => {
    const item = data.itemStack;
    const player = data.source

    if (item.typeId === "minecraft:compass") { player.runCommandAsync(`tag @s remove skillread`) }
})


world.afterEvents.itemUse.subscribe((data) => {

    const player = data.source;
    const item = data.itemStack;

    const menu = new ActionFormData()
        .title("Viral Coral : Menu")
        .button("Command")
        .button("Quick Commands")
        .button("effects")
        .button("Pranks")
        .button("Chat Message")
        .button("Items");

    const effectmenu = new ActionFormData()
        .title("Effect Menu.")
        .button("IMMORTALITY")
        .button("SPEED")
        .button("STRENGTH")
        .button("HASTE")
        .button("NIGHT VISION")
        .button("CLEAR")
        .button("SATURATION");

    const Commandmenu = new ModalFormData()
        .title("VC- Command")
        .textField("", "", "");

    const quickcommandsmenu = new ActionFormData()
        .title("Quick Commands~")
        .button("Creative")
        .button("survival")
        .button("Day")
        .button("Night")
        .button("32k kit");

    const chatmessage = new ModalFormData()
        .title("Chat Message")
        .textField("Message", "", "");

    const itemmenu = new ActionFormData()
        .title("Items")
        .button("Wand")

    const prankmenu = new ActionFormData()
        .title("Prank Menu")
        .button("explode all")
        .button("summon 10 withers")
        .button("Start Time loop")
        .button("Stop Time loop")
        .button("Start Inventory crush")
        .button("UWU")
        .button("no UwU")
        .button("Start Toon World")
        .button("Stop Toon World");

    if (item.typeId === "minecraft:ghast_tear") {
        menu.show(player).then((Response) => {

            //---------------EFFECT MENU
            if (Response.selection == 2) {
                effectmenu.show(player).then((response) => {
                    if (response.canceled) { menu.show(player) }
                    if (response.selection == 0) { player.runCommandAsync("effect @s resistance 99999 255 true") }
                    if (response.selection == 1) { player.runCommandAsync("effect @s speed 99999 7 true") }
                    if (response.selection == 2) { player.runCommandAsync("effect @s strength 99999 255 true") }
                    if (response.selection == 3) { player.runCommandAsync("effect @s haste 99999 255 true") }
                    if (response.selection == 4) { player.runCommandAsync("effect @s night_vision 99999 255 true") }
                    if (response.selection == 5) { player.runCommandAsync("effect @s clear") }
                    if (response.selection == 6) { player.runCommandAsync("effect @s saturation 99999 255 true") }

                })
            }
            //-------------------COMMAND 
            if (Response.selection == 0) {
                if (Response.canceled) { menu.show(player) }
                if (Response.selection == 0) {
                    Commandmenu.show(player).then((Response) => {
                        const vcc = Response.formValues;
                        player.runCommandAsync(`${vcc}`)
                        player.sendMessage(`§5[VC-Command run  "${vcc}" ]`)
                    })
                }

            }
            //--------------QUICK COMMAND
            if (Response.selection == 1) {
                quickcommandsmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("gamemode c"), (player.sendMessage("§5[VC-Gamemode Changed to creative]")) }
                    if (Response.selection == 1) { player.runCommandAsync("gamemode s"), (player.sendMessage("§5[VC-Gamemode Changed to Survival]")) }
                    if (Response.selection == 2) { player.runCommandAsync("time set day"), (player.sendMessage("§5[VC-Time set to day]")) }
                    if (Response.selection == 3) { player.runCommandAsync("time set midnight"), (player.sendMessage("§5[VC-Time set to midnight]")) }
                    if (Response.selection == 4) { player.runCommandAsync("structure load vc_k ~ ~ ~"), (player.sendMessage("§5[VC-32k kit Given]")) }

                })
                //---------------CHAT MESSAGE
            }
            if (Response.selection == 4) {
                chatmessage.show(player).then((Response) => {
                    const msg = Response.formValues;
                    player.runCommandAsync(`/tellraw @a {"rawtext":[{"text":"${msg}"}]}`)
                })
            }
            //---------------ITEMS MENU
            if (Response.selection == 5) {
                itemmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("structure load vc_wa ~~~") }

                })
            }

            if (Response.selection == 3) {
                prankmenu.show(player).then((Response) => {
                    if (Response.selection == 0) { player.runCommandAsync("execute at @e[rm=2] run /summon tnt"), (player.sendMessage("§5[VC-Tnt summoned]")) }
                    if (Response.selection == 1) { player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), player.runCommandAsync("summon wither"), (player.sendMessage("§5[VC-wither storm!]")) }
                    if (Response.selection == 2) { player.runCommandAsync("tag @s add force_time_loop"), (player.sendMessage("§5[VC-Enabled Time loop]")) }
                    if (Response.selection == 3) { player.runCommandAsync("tag @s remove force_time_loop"), (player.sendMessage("§5[VC-Disabled Time loop]")) }
                    if (Response.selection == 4) { player.runCommandAsync("tag @s add force_inventory_crush"), (player.sendMessage("§5[VC-Crushed inventorys]")) }
                    if (Response.selection == 5) { player.runCommandAsync("tag @s add uwu_spam"), (player.sendMessage("§5[VC-UwU Daddy~]")) }
                    if (Response.selection == 6) { player.runCommandAsync("tag @s remove uwu_spam"), (player.sendMessage("§5[VC-UwU sorry]")) }
                    if (Response.selection == 7) { player.runCommandAsync("tag @s add force_toonworld"), (player.sendMessage("§5[VC-TOON WORLD!!]")) }
                    if (Response.selection == 8) { player.runCommandAsync("tag @s remove force_toonworld"), (player.sendMessage("§5[VC-aww.. no toon world]")) }
                })
            }

        })
    }
});
